## mpi4py 3.1.2

=== debian/changelog ===
mpi4py (3.1.2-2) unstable; urgency=medium

  * Team upload.
  * update debian/control Homepage and debian/watch to
    https://github.com/mpi4py/mpi4py

 -- Drew Parsons <dparsons@debian.org>  Sat, 20 Nov 2021 13:26:18 +0100

mpi4py (3.1.2-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - applies debian patch test_align_PR92.patch

 -- Drew Parsons <dparsons@debian.org>  Fri, 05 Nov 2021 22:22:08 +0100

mpi4py (3.1.1-8) unstable; urgency=medium

  * Team upload.
  * upload new version to unstable

 -- Drew Parsons <dparsons@debian.org>  Sun, 26 Sep 2021 20:55:06 +0200

mpi4py (3.1.1-7) experimental; urgency=medium

  * Team upload.
  * stop providing python3-mpi4py-dbg. Python debug builds are now
    ABI compatible with standard builds. Closes: #994312.
  * rename debian patch skip_tests_riscv64.patch to
    skip_test_dynproc.patch and add ia64.
  * drop NUM_TEST_PROCESSES for tests, revert to 5 processes

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Sep 2021 02:55:02 +0200

mpi4py (3.1.1-6) experimental; urgency=medium

  * Team upload.
  * use NUM_TEST_PROCESSES to set number of processes used in
    build-time tests. Default 5, set to 3 for "weak MPI" arches which
    handle oversubscription poorly.
    Currently WEAK_MPI_ARCH_LIST = ia64 only.
  * debian patch skip_tests_riscv64.patch skips TestDPM.testJoin on
    riscv64, which stalls in build-time tests.

 -- Drew Parsons <dparsons@debian.org>  Thu, 16 Sep 2021 14:51:13 +0200

mpi4py (3.1.1-5) experimental; urgency=medium

  * Team upload.
  * run build-time tests on 2 processors with -fv flag to help
    identify ia64 and riscv64 test failures.

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 Sep 2021 10:33:19 +0200

mpi4py (3.1.1-4) experimental; urgency=medium

  * Team upload.
  * update debian patch test_align_PR92.patch from upstream PR#92.

 -- Drew Parsons <dparsons@debian.org>  Tue, 14 Sep 2021 12:13:21 +0200

mpi4py (3.1.1-3) experimental; urgency=medium

  * Team upload.
  * debian patch test_align_PR92.patch applies upstream PR#92 to fix
    long double alignment in tests for s390x.
  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Sun, 12 Sep 2021 01:24:17 +0300

mpi4py (3.1.1-2) experimental; urgency=medium

  * Team upload.
  * apply OpenMPI settings in debian/rules to make build tests more
    reliable (oversubscribe in particular). See
    https://github.com/mpi4py/setup-mpi/blob/master/setup-mpi.sh#L65
  * debian patch skip_spawn_tests.patch skips all spawn tests
    (test_spawn.py) for OpenMPI. Spawn not stable in OpenMPI 4, see
    https://github.com/jsquyres/ompi/pull/4#issuecomment-806897758
    In particular it causes builds to fail in chroots (buildds).

 -- Drew Parsons <dparsons@debian.org>  Thu, 19 Aug 2021 23:55:57 +0200

mpi4py (3.1.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - applies debian patches
      docs_sphinx_python3.patch, fix_pytest4.patch, up_libm
  * run tests using test/runtests.py (otherwise there could be CUDA
    configuration problems, see upstream Issue #80)
    - drop Build-Depends: python3-nose
    - run verbose tests on single processor,
      then full tests with mpirun -n 5, non-verbose
  * override dh_auto_clean: remove generated docs/source/usrman/reference
  * use pybuild build_dir as PYTHONPATH during build
  * drop debian patch up_tests_network_attr
    (trying to run tests without nose)

 -- Drew Parsons <dparsons@debian.org>  Tue, 17 Aug 2021 17:06:47 +0200

mpi4py (3.0.3-10) unstable; urgency=medium

  * Team upload.
  * reinstate Depends: python3-pytest in debian/tests.
  * add dummy test to debian/tests/control so that mpi4py tests are
    triggered by changes to libpmix-dev, libucx-dev (selected arches)
    Thanks Graham Inggs for the patch.

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Aug 2021 12:46:38 +0200

mpi4py (3.0.3-9) unstable; urgency=medium

  * Team upload.
  * debian patch skip_spawn_tests.patch skips all spawn tests
    (test_spawn.py) for OpenMPI. Spawn not stable in OpenMPI 4, see
    https://github.com/jsquyres/ompi/pull/4#issuecomment-806897758
    In particular it causes builds to fail in chroots (buildds).
    MPI spawn instability appears to have been triggered by
    pmix/4.1.0-3. Closes: #993214,

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 Aug 2021 11:25:54 +0200

mpi4py (3.0.3-8) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.1

 -- Drew Parsons <dparsons@debian.org>  Thu, 21 Jan 2021 15:54:22 +0100

mpi4py (3.0.3-7) unstable; urgency=medium

  * Team upload.
  * extend debian patch skip_failing_test_rma.patch to skip the
    affected tests for any openmpi release >=4.0.4,<4.1. Review fails
    when openmpi 4.1 is released. Closes: #974560.

 -- Drew Parsons <dparsons@debian.org>  Sat, 14 Nov 2020 12:56:39 +0800

mpi4py (3.0.3-6) unstable; urgency=medium

  * Team upload.
  * debian patch skip_failing_test_rma.patch skips
    tests in test_rma.py, test_rma_nb.py and test_win.py which
    segfault or fail with OpenMPI 4.0.4
    See Bug#965352 and upstream Issue #171.

 -- Drew Parsons <dparsons@debian.org>  Sat, 08 Aug 2020 09:32:42 +0800

mpi4py (3.0.3-5) unstable; urgency=medium

  * Team upload.
  * use verbose output with pytest in debian/tests (autopkgtest)
  * debhelper compatibility level 13

 -- Drew Parsons <dparsons@debian.org>  Sun, 19 Jul 2020 23:23:42 +0800

mpi4py (3.0.3-4) unstable; urgency=medium

  * Team upload.
  * debian patch skip_ppc_failing_tests.patch skips tests
    testCreateF90RealDouble and testCreateF90ComplexDouble in
    test_datatype.py on all ppc arches, where they fail with OpenMPI 4.
    These tests pass on other arches. See Bug#948655.
  * Standards-Version: 4.5.0

 -- Drew Parsons <dparsons@debian.org>  Sun, 26 Jan 2020 06:22:02 +0800

mpi4py (3.0.3-3) unstable; urgency=medium

  * Team upload.
  * restore installation of python3-dbg module libs in python3-mpi4py-dbg



=== debian/control ===
Source: mpi4py
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>
Section: python
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               mpi-default-dev,
               mpi-default-bin,
               rsh-client | openssh-client,
               cython3,
               python3-all-dev,
               python3-numpy,
               python3-sphinx
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/mpi4py
Vcs-Git: https://salsa.debian.org/science-team/mpi4py.git
Homepage: https://github.com/mpi4py/mpi4py

Package: python3-mpi4py
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         mpi-default-bin
Suggests: python3-numpy
Description: bindings of the Message Passing Interface (MPI) standard
 MPI for Python (mpi4py) provides bindings of the Message Passing
 Interface (MPI) standard for the Python programming language,
 allowing any Python program to exploit multiple processors.
 .
 mpi4py is constructed on top of the MPI-1/MPI-2 specification
 and provides an object oriented interface which closely follows MPI-2
 C++ bindings.  It supports point-to-point (sends, receives) and
 collective (broadcasts, scatters, gathers) communications of any
 picklable Python object as well as optimized communications of Python
 object exposing the single-segment buffer interface (NumPy arrays,
 builtin bytes/string/array objects).

Package: python-mpi4py-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: python3-mpi4py
Description: bindings of the MPI standard -- documentation
 MPI for Python (mpi4py) provides bindings of the Message Passing
 Interface (MPI) standard for the Python programming language,
 allowing any Python program to exploit multiple processors.
 .
 mpi4py is constructed on top of the MPI-1/MPI-2 specification
 and provides an object oriented interface which closely follows MPI-2
 C++ bindings.  It supports point-to-point (sends, receives) and
 collective (broadcasts, scatters, gathers) communications of any
 picklable Python object as well as optimized communications of Python
 object exposing the single-segment buffer interface (NumPy arrays,
 builtin bytes/string/array objects).
 .
 This package provides HTML rendering of the user's manual.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

PY3 = $(shell py3versions -vd)
PY3VERS = $(shell py3versions -vr)

LAST_CHANGE = $(shell dpkg-parsechangelog -S Date)
BUILD_DATE  = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "$(LAST_CHANGE)")

# build-time tests should be more reliable with these settings
# see https://github.com/mpi4py/setup-mpi/blob/master/setup-mpi.sh#L65
export OMPI_MCA_plm=isolated
export OMPI_MCA_rmaps_base_oversubscribe=true
export OMPI_MCA_btl_base_warn_component_unused=false
export OMPI_MCA_btl_vader_single_copy_mechanism=none

# Specify a specific version of MPI to use in the build, otherwise
# just use the default.
# MPI=.openmpi

export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/


# disable build tests for these arches:
# x32 consistently times out on tests
NO_TEST_ARCH_LIST = x32

empty :=
space := $(empty)$(empty)

# run tests, or not
RUNTEST=yes
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(NO_TEST_ARCH_LIST)$(space)))
  RUNTEST=no
endif
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUNTEST=no
endif

# hurd fails a couple of tests
# but hell, hurd needs all the help it can get, so let it pass
ARCH_IGNORE_FAILED_TESTS = hurd-i386

# normally, do not ignore test failures
IGNORE_FAILED_TESTS=/bin/false
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_IGNORE_FAILED_TESTS)$(space)))
  IGNORE_FAILED_TESTS=/bin/true
endif

%:
	dh $@ --with python3,sphinxdoc --buildsystem pybuild

cythonize:
	@echo "D: removing previously generated by Cython sources"
	find -iname *.c | xargs grep -l 'Generated by Cython' | xargs -r rm
	python3 setup.py build_src

override_dh_autoreconf:
	dh_autoreconf debian/rules -- cythonize

override_dh_auto_build-arch:
	dh_auto_build $@ -- \
		--build-args "--mpicc=/usr/bin/mpicc$(MPI) --mpicxx=/usr/bin/mpicxx$(MPI)"

override_dh_auto_build-indep: override_dh_auto_build-arch
	PYTHONPATH=`pybuild --print "{build_dir}"` \
	 make -C docs/source/usrman/ html man SPHINXOPTS="-D today=\"$(BUILD_DATE)\""

override_dh_auto_install:
	dh_auto_install

	: # Remove python-mpi binaries
	find $(CURDIR)/debian/tmp -name python-mpi -delete
	find $(CURDIR)/debian/tmp -type d -empty -delete

override_dh_install-arch:
	dh_install
	: # create symlinks for .h files
	: # Can have python$$v symlink pointing to python3.?m or python3.?mu
	: # see #700995 for more details.  So first look where it points to
	: # and use that directory
	set -e; for v in $(PY3VERS); do \
	ABITAG=`python$$v -c "import sys; print(sys.abiflags)"`; \
	[ -d $(CURDIR)/debian/python3-mpi4py/usr/include/python$$v$$ABITAG ] || \
		mkdir -p $(CURDIR)/debian/python3-mpi4py/usr/include/python$$v$$ABITAG; \
		dh_link -ppython3-mpi4py usr/lib/python3/dist-packages/mpi4py/include/mpi4py usr/include/python$$v$$ABITAG/mpi4py; \
	done

override_dh_auto_test:
	set -e; \
	if [ "$(RUNTEST)" = "no" ]; then \
	  echo Build tests have been disabled; \
	else \
	  for vv in $(PY3VERS); do \
	  echo "I: testing using python$$vv"; \
	   echo "I: running tests with single process"; \
	   PYTHONPATH=`pybuild -p $$vv --print "{build_dir}"` \
	    /usr/bin/python$$vv $(CURDIR)/test/runtests.py -v || $(IGNORE_FAILED_TESTS); \
	   echo "I: running tests with MPI (5 processes)"; \
	   PYTHONPATH=`pybuild -p $$vv --print "{build_dir}"` \
	    mpirun -n 5 /usr/bin/python$$vv $(CURDIR)/test/runtests.py -fv || $(IGNORE_FAILED_TESTS); \
	  done; \
	fi

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	dh_sphinxdoc -ppython-mpi4py-doc
endif

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.rst

## Immediately useable documentation
override_dh_compress:
	dh_compress -X.py -X.html -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -X.par -X.bin -Xobjects.inv

override_dh_dwz:
	echo "dh_dwz is currently deactivated since it generates an error: \".debug_line reference above end of section\""

override_dh_auto_clean:
	dh_auto_clean $@
	rm -rf `find -name build -type d`
	rm -rf `find -name _build -type d`
	rm -rf docs/source/usrman/reference

	: # Remove Cython generated files
	rm -f src/mpi4py.MPE.c src/mpi4py.MPI.c src/include/mpi4py/mpi4py.MPI_api.h

get-orig-dev-source:
	cd ../mpi4py-hg/; \
	uver=`sed -ne "/__version__/s,.*= *'\(.*\)' *$$,\1,gp" src/__init__.py`; \
	tarball=../tarballs/mpi4py_$$uver+hg`date +"20%y%m%d"`.orig.tar.gz; \
	echo "I: Generating $$tarball"; \
	hg archive --exclude 'misc' -t tgz $$tarball;

## mpi4py 3.1.3

=== debian/changelog ===
mpi4py (3.1.3-1build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 22:47:46 +0000

mpi4py (3.1.3-1build1) jammy; urgency=medium

  * Rebuild against new pmix 4.1.2-1ubuntu1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 14 Feb 2022 21:31:41 +0100

mpi4py (3.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - adds missing support for MPI.BOTTOM to generalized all-to-all
      collectives
    - no longer provides mpi4py.pdf or info files. Build from source.
      Build-Depends-Indep: texinfo, texlive, latexmk, tex-gyre,
      texlive-latex-extra. Don't compress pdf file.
  * debian patch docs_privacy.patch disables inclusion of
    googletagmanager in docs in order to maintain privacy.

 -- Drew Parsons <dparsons@debian.org>  Sun, 05 Dec 2021 22:28:02 +0100

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,9 @@
                python3-all-dev,
                python3-numpy,
                python3-sphinx
+Build-Depends-Indep: texinfo, texlive,
+ latexmk, tex-gyre,
+ texlive-latex-extra
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/science-team/mpi4py
 Vcs-Git: https://salsa.debian.org/science-team/mpi4py.git

=== debian/tests/control ===
# testing on 5 processes is recommended by upstream where possible
# and is safe to oversubscribe with OpenMPI
# but oversubscribing might be a problem (runs slow) with mpich

Test-Command: OMPI_MCA_rmaps_base_oversubscribe=yes mpiexec -n 5 python3 test/runtests.py --verbose
Depends: python3-mpi4py,
    python3-cffi,
    python3-dill,
    python3-distutils,
    python3-numpy,
    python3-simplejson,
    python3-yaml
Restrictions: allow-stderr


# Dummy test so that changes to other packages
# trigger our autopkgtests on ci.debian.net
Test-Command: /bin/true
Depends: libpmix-dev,
    libucx-dev [amd64 arm64 ppc64el],
Restrictions: hint-testsuite-triggers

## mpi4py 3.1.4

=== conf/CMakeLists.txt ===
# Author:  Lisandro Dalcin
# Contact: dalcinl@gmail.com
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

PROJECT(mpi4py)

SET(PythonInterp_FIND_VERSION ${PYTHON_VERSION})
SET(PythonLibs_FIND_VERSION   ${PYTHON_VERSION_STRING})

FIND_PACKAGE(PythonInterp)
FIND_PACKAGE(PythonLibs)
FIND_PACKAGE(MPI)

SET(mpi4py_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src")
SET(mpi4py_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/mpi4py")

FILE(GLOB mpi4py_PYTHON_FILES
     RELATIVE ${mpi4py_SOURCE_DIR}/mpi4py
     ${mpi4py_SOURCE_DIR}/mpi4py/*.py
     ${mpi4py_SOURCE_DIR}/mpi4py/futures/*.py
     ${mpi4py_SOURCE_DIR}/mpi4py/util/*.py
     )

FILE(GLOB mpi4py_HEADER_FILES
     RELATIVE ${mpi4py_SOURCE_DIR}/mpi4py
     ${mpi4py_SOURCE_DIR}/mpi4py/*.pxd
     ${mpi4py_SOURCE_DIR}/mpi4py/include/mpi4py/*.[hi]
     ${mpi4py_SOURCE_DIR}/mpi4py/include/mpi4py/*.px[di]
     )

FILE(GLOB mpi4py_STUBS_FILES
     RELATIVE ${mpi4py_SOURCE_DIR}/mpi4py
     ${mpi4py_SOURCE_DIR}/mpi4py/py.typed
     ${mpi4py_SOURCE_DIR}/mpi4py/*.pyi
     ${mpi4py_SOURCE_DIR}/mpi4py/futures/*.pyi
     ${mpi4py_SOURCE_DIR}/mpi4py/util/*.pyi
     )

FOREACH(file
        ${mpi4py_PYTHON_FILES}
        ${mpi4py_HEADER_FILES}
        ${mpi4py_STUBS_FILES}
        )
  SET(src "${mpi4py_SOURCE_DIR}/mpi4py/${file}")
  SET(tgt "${mpi4py_BINARY_DIR}/${file}")
  ADD_CUSTOM_COMMAND(
    DEPENDS ${src}
    OUTPUT  ${tgt}
    COMMAND ${CMAKE_COMMAND} ARGS -E copy ${src} ${tgt}
    COMMENT "copy: ${file}"
    )
  SET(mpi4py_OUTPUT_FILES ${mpi4py_OUTPUT_FILES} ${tgt})
ENDFOREACH(file)


FIND_PROGRAM(MPI_COMPILER_CC
  NAMES mpicc
  HINTS "${MPI_BASE_DIR}"
  PATH_SUFFIXES bin
  DOC "MPI C compiler wrapper")
MARK_AS_ADVANCED(MPI_COMPILER_CC)
FIND_PROGRAM(MPI_COMPILER_CXX
  NAMES mpicxx mpic++ mpiCC
  HINTS "${MPI_BASE_DIR}"
  PATH_SUFFIXES bin
  DOC "MPI C++ compiler wrapper")
MARK_AS_ADVANCED(MPI_COMPILER_CXX)
find_program(MPI_COMPILER_FC
  NAMES mpifort mpif90 mpif77
  HINTS "${MPI_BASE_DIR}"
  PATH_SUFFIXES bin
  DOC "MPI Fortran compiler wrapper")
MARK_AS_ADVANCED(MPI_COMPILER_FC)
FIND_PROGRAM(MPI_COMPILER_F90
  NAMES mpif90
  HINTS "${MPI_BASE_DIR}"
  PATH_SUFFIXES bin
  DOC "MPI Fortran 90 compiler wrapper")
MARK_AS_ADVANCED(MPI_COMPILER_F90)
find_program(MPI_COMPILER_F77
  NAMES mpif77
  HINTS "${MPI_BASE_DIR}"
  PATH_SUFFIXES bin
  DOC "MPI Fortran 77 compiler wrapper")
MARK_AS_ADVANCED(MPI_COMPILER_F77)
FOREACH(file "mpi.cfg")
  SET(tgt "${mpi4py_BINARY_DIR}/${file}")
  ADD_CUSTOM_COMMAND(
    OUTPUT  ${tgt}
    COMMAND ${CMAKE_COMMAND} ARGS -E echo '[mpi]' > "${tgt}"
    COMMAND ${CMAKE_COMMAND} ARGS -E echo 'mpicc = ${MPI_COMPILER_CC}'   >> ${tgt}
    COMMAND ${CMAKE_COMMAND} ARGS -E echo 'mpicxx = ${MPI_COMPILER_CXX}' >> ${tgt}
    COMMAND ${CMAKE_COMMAND} ARGS -E echo 'mpifort = ${MPI_COMPILER_FC}' >> ${tgt}
    COMMAND ${CMAKE_COMMAND} ARGS -E echo 'mpif90 = ${MPI_COMPILER_F90}' >> ${tgt}
    COMMAND ${CMAKE_COMMAND} ARGS -E echo 'mpif77 = ${MPI_COMPILER_F77}' >> ${tgt}
    COMMAND ${CMAKE_COMMAND} ARGS -E echo '' >> ${tgt}
    COMMENT "write: ${file}"
    )
  SET(mpi4py_OUTPUT_FILES ${mpi4py_OUTPUT_FILES} ${tgt})
ENDFOREACH(file)

ADD_CUSTOM_TARGET(mpi4py ALL DEPENDS ${mpi4py_OUTPUT_FILES})

INCLUDE_DIRECTORIES(
  ${MPI_INCLUDE_PATH}
  ${PYTHON_INCLUDE_PATH}
  "${mpi4py_SOURCE_DIR}"
  )

# --- mpi4py.MPI ---
PYTHON_ADD_MODULE(mpi4py.MPI MODULE "${mpi4py_SOURCE_DIR}/MPI.c")
SET_TARGET_PROPERTIES(
  mpi4py.MPI PROPERTIES
  OUTPUT_NAME "MPI" PREFIX ""
  COMPILE_FLAGS "${MPI_COMPILE_FLAGS}"
  LINK_FLAGS "${MPI_LINK_FLAGS}"
  LIBRARY_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}"
  RUNTIME_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}"
  LINKER_LANGUAGE C
)
TARGET_LINK_LIBRARIES(mpi4py.MPI ${PYTHON_LIBRARY})
TARGET_LINK_LIBRARIES(mpi4py.MPI ${MPI_LIBRARIES})


# --- mpi4py.dl ---
PYTHON_ADD_MODULE(mpi4py.dl MODULE "${mpi4py_SOURCE_DIR}/dynload.c")
SET_TARGET_PROPERTIES(
  mpi4py.dl PROPERTIES
  OUTPUT_NAME "dl" PREFIX ""
  LIBRARY_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}"
  RUNTIME_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}"
  LINKER_LANGUAGE C
)
TARGET_LINK_LIBRARIES(mpi4py.dl ${PYTHON_LIBRARY})
TARGET_LINK_LIBRARIES(mpi4py.dl ${CMAKE_DL_LIBS})


# --- mpi4py/bin/python-mpi ---
ADD_EXECUTABLE(python-mpi "${mpi4py_SOURCE_DIR}/python.c")
SET_TARGET_PROPERTIES(
  python-mpi PROPERTIES
  COMPILE_FLAGS "${MPI_COMPILE_FLAGS}"
  LINK_FLAGS "${MPI_LINK_FLAGS}"
  RUNTIME_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/bin"
  LINKER_LANGUAGE C
)
TARGET_LINK_LIBRARIES(python-mpi ${PYTHON_LIBRARY})
TARGET_LINK_LIBRARIES(python-mpi ${MPI_LIBRARIES})

# --- mpi4py/lib-pmpi/libmpe.so ---
ADD_LIBRARY(pmpi-mpe MODULE "${mpi4py_SOURCE_DIR}/lib-pmpi/mpe.c")
SET_TARGET_PROPERTIES(
  pmpi-mpe PROPERTIES
  OUTPUT_NAME "mpe"
  LIBRARY_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/lib-pmpi"
  RUNTIME_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/lib-pmpi"
  LINKER_LANGUAGE C
)
TARGET_LINK_LIBRARIES(pmpi-mpe ${MPE_LIBRARIES})
TARGET_LINK_LIBRARIES(pmpi-mpe ${MPI_LIBRARIES})

# --- mpi4py/lib-pmpi/libvt.so ---
ADD_LIBRARY(pmpi-vt MODULE "${mpi4py_SOURCE_DIR}/lib-pmpi/vt.c")
SET_TARGET_PROPERTIES(
  pmpi-vt PROPERTIES
  OUTPUT_NAME "vt"
  LIBRARY_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/lib-pmpi"
  RUNTIME_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/lib-pmpi"
  LINKER_LANGUAGE C
)
TARGET_LINK_LIBRARIES(pmpi-vt ${VT_LIBRARIES})
TARGET_LINK_LIBRARIES(pmpi-vt ${MPI_LIBRARIES})

# --- mpi4py/lib-pmpi/libvt-mpi.so ---
ADD_LIBRARY(pmpi-vt-mpi MODULE "${mpi4py_SOURCE_DIR}/lib-pmpi/vt-mpi.c")
SET_TARGET_PROPERTIES(
  pmpi-vt-mpi PROPERTIES
  OUTPUT_NAME "vt-mpi"
  LIBRARY_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/lib-pmpi"
  RUNTIME_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/lib-pmpi"
  LINKER_LANGUAGE C
)
TARGET_LINK_LIBRARIES(pmpi-vt-mpi ${VT_MPI_LIBRARIES})
TARGET_LINK_LIBRARIES(pmpi-vt-mpi ${MPI_LIBRARIES})

# --- mpi4py/lib-pmpi/libvt-hyb.so ---
ADD_LIBRARY(pmpi-vt-hyb MODULE "${mpi4py_SOURCE_DIR}/lib-pmpi/vt-hyb.c")
SET_TARGET_PROPERTIES(
  pmpi-vt-hyb PROPERTIES
  OUTPUT_NAME "vt-hyb"
  LIBRARY_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/lib-pmpi"
  RUNTIME_OUTPUT_DIRECTORY "${mpi4py_BINARY_DIR}/lib-pmpi"
  LINKER_LANGUAGE C
)
TARGET_LINK_LIBRARIES(pmpi-vt-hyb ${VT_HYB_LIBRARIES})
TARGET_LINK_LIBRARIES(pmpi-vt-hyb ${MPI_LIBRARIES})

=== debian/changelog ===
mpi4py (3.1.4-2) unstable; urgency=medium

  * Team upload.
  * debian patch skip_testPackUnpackExternal_sparc64.patch skips
    testPackUnpackExternal on sparc64. See upstream Issue#147.

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Nov 2022 17:27:32 +0100

mpi4py (3.1.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - applies debian patches contiguity_check_9ccf55f.patch,
      numpy_1.22_DLPack_e3e4e02.patch, test_ipv6.patch

 -- Drew Parsons <dparsons@debian.org>  Thu, 03 Nov 2022 17:54:51 +0100

mpi4py (3.1.3-4) unstable; urgency=medium

  * Team upload.
  * apply patches recommended upstream from maint branch
    - contiguity_check_9ccf55f.patch
    - numpy_1.22_DLPack_e3e4e02.patch applies commit e3e4e02 after
      c252c9c and 069bfde to pass with numpy 1.22.
  * update debian patch test_ipv6.patch against upstream PR#241

 -- Drew Parsons <dparsons@debian.org>  Thu, 11 Aug 2022 16:21:39 +0200

mpi4py (3.1.3-3) unstable; urgency=medium

  * Team upload.
  * debian patch test_ipv6.patch tests available internet sockets in
    order to use IPv4 or IPv6 in test_dynproc.TestDPM.testJoin.
    Select IPv4 if available, else IPv6, UNIX or the first available
    (undocumented) socket family. Closes: #1015912.
  * Standards-Version: 4.6.1

 -- Drew Parsons <dparsons@debian.org>  Tue, 09 Aug 2022 15:18:47 +0200

mpi4py (3.1.3-2) unstable; urgency=medium

  * Team upload.
  * debian patch io_long_double_i386_2d868d7.patch applies upstream
    commit 2d868d7 to skip test_io long double tests on i386.
    See upstream mpi4py issue #105, openmpi issue #10287.
    Closes: #998106.

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Apr 2022 12:21:10 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 Build-Depends-Indep: texinfo, texlive,
  latexmk, tex-gyre,
  texlive-latex-extra
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/science-team/mpi4py
 Vcs-Git: https://salsa.debian.org/science-team/mpi4py.git
 Homepage: https://github.com/mpi4py/mpi4py

=== debian/rules ===
--- 
+++ 
@@ -65,7 +65,7 @@
 
 override_dh_auto_build-indep: override_dh_auto_build-arch
 	PYTHONPATH=`pybuild --print "{build_dir}"` \
-	 make -C docs/source/usrman/ html man SPHINXOPTS="-D today=\"$(BUILD_DATE)\""
+	 make -C docs/source/usrman/ html man info latexpdf SPHINXOPTS="-D today=\"$(BUILD_DATE)\""
 
 override_dh_auto_install:
 	dh_auto_install
@@ -113,7 +113,7 @@
 
 ## Immediately useable documentation
 override_dh_compress:
-	dh_compress -X.py -X.html -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -X.par -X.bin -Xobjects.inv
+	dh_compress -X.py -X.html -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -X.par -X.bin -Xobjects.inv -X.pdf
 
 override_dh_dwz:
 	echo "dh_dwz is currently deactivated since it generates an error: \".debug_line reference above end of section\""

## mpi4py 3.1.5

=== debian/changelog ===
mpi4py (3.1.5-5) unstable; urgency=medium

  * Team upload

  [ Matthias Klose ]
  * Let the autopkg test depend on setuptools instead of distutils.
    Closes: #1061813

  [ Andreas Tille ]
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Do not parse d/changelog (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * No tab in license text (routine-update)
  * Use correct machine-readable copyright file URI.
  * Add missing build-dependency on python3-setuptools.
  * Add upstream metadata
  * Remove debian/gbp.conf since it contains only default values from
    team policy

 -- Andreas Tille <tille@debian.org>  Tue, 20 Feb 2024 11:49:49 +0100

mpi4py (3.1.5-4) unstable; urgency=medium

  * Team upload.
  * Drop unused Build-Depends: rsh-client.

 -- Bastian Germann <bage@debian.org>  Sun, 14 Jan 2024 20:58:06 +0000

mpi4py (3.1.5-3) unstable; urgency=medium

  * Team upload.
  * reactivate skip_ppc_failing_tests.patch. ppc* is still failing
    testCreateF90{Complex,Real}Double with openmpi 4.1.6.
  * update skip_testPackUnpackExternal_sparc64.patch to skip
    testPackUnpackExternal on sparc64 for all OpenMPI versions <5.0.
    Review next time with OpenMPI 5. See Bug#1059791.

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Jan 2024 14:24:22 +0100

mpi4py (3.1.5-2) unstable; urgency=medium

  * Team upload.
  * Build-Depends: cython3-legacy
  * disable debian patch skip_ppc_failing_tests.patch to check if
    testCreateF90{Complex,Real}Double now passes on ppc* (Bug#948655)

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Jan 2024 10:03:27 +0100

mpi4py (3.1.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Oct 2023 10:38:49 +0100

=== debian/control ===
--- 
+++ 
@@ -5,21 +5,23 @@
 Section: python
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                mpi-default-dev,
                mpi-default-bin,
-               rsh-client | openssh-client,
-               cython3,
+               openssh-client,
+               cython3-legacy,
                python3-all-dev,
                python3-numpy,
-               python3-sphinx
+               python3-sphinx,
+               python3-setuptools
 Build-Depends-Indep: texinfo, texlive,
  latexmk, tex-gyre,
  texlive-latex-extra
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/mpi4py
 Vcs-Git: https://salsa.debian.org/science-team/mpi4py.git
 Homepage: https://github.com/mpi4py/mpi4py
+Rules-Requires-Root: no
 
 Package: python3-mpi4py
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -49,7 +49,7 @@
 endif
 
 %:
-	dh $@ --with python3,sphinxdoc --buildsystem pybuild
+	dh $@ --with sphinxdoc --buildsystem pybuild
 
 cythonize:
 	@echo "D: removing previously generated by Cython sources"

=== debian/tests/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Depends: python3-mpi4py,
     python3-cffi,
     python3-dill,
-    python3-distutils,
+    python3-setuptools,
     python3-numpy,
     python3-simplejson,
     python3-yaml

## mpi4py 3.1.6

=== debian/changelog ===
mpi4py (3.1.6-9ubuntu1) oracular; urgency=medium

  * Restore test_pack skipping in skip_failing_tests_32bit_mpich.patch

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 05 Sep 2024 10:51:28 +0000

mpi4py (3.1.6-9) unstable; urgency=medium

  * debian patch mpich_32bit_13e8af6.patch applies upstream commit
    13e8af6 to better handle 32-bit architectures.
    Drop test_pack skipping from skip_failing_tests_32bit_mpich.patch

 -- Drew Parsons <dparsons@debian.org>  Fri, 19 Jul 2024 11:47:14 +0200

mpi4py (3.1.6-8) unstable; urgency=medium

  * update debian patch skip_failing_tests_32bit_mpich.patch to skip
    spawn tests (BaseTestSpawn) with mpich on all 32-bit systems.

 -- Drew Parsons <dparsons@debian.org>  Wed, 17 Jul 2024 23:46:26 +0200

mpi4py (3.1.6-7) unstable; urgency=medium

  * update debian patch skip_failing_tests_32bit_mpich.patch to skip
    testPackUnpackExternal with mpich on all 32-bit systems.
    The previous i386 "success" was actually an ignored failure.

 -- Drew Parsons <dparsons@debian.org>  Wed, 17 Jul 2024 13:39:02 +0200

mpi4py (3.1.6-6) unstable; urgency=medium

  * debian patch test_exception_MPI_ERR_ERRHANDLER_mpich.patch defines
    MPI_ERR_ERRHANDLER=80 to enable mpich to pass test_exceptions.py.
    MPI_ERR_ERRHANDLER is defined and used by mpich 4.2 but not yet
    implemented by openmpi 4.1.6. See upstream Issue#514.

 -- Drew Parsons <dparsons@debian.org>  Sun, 14 Jul 2024 10:42:42 +0200

mpi4py (3.1.6-5) unstable; urgency=medium

  * update skip_failing_tests_32bit_mpich.patch to skip all spawn tests
    (BaseTestSpawn) for failing mpich 32-bit arches
    (armel, armhf, hppa, powerpc)

 -- Drew Parsons <dparsons@debian.org>  Fri, 12 Jul 2024 12:04:34 +0200

mpi4py (3.1.6-4) unstable; urgency=medium

  * update skip_failing_tests_32bit_mpich.patch to skip testCommSpawn
    on 32-bit mpich, and apply spawn skips to armel, armhf, hppa.
  * run tests with mpi -v verbose flag to help debug mpich failures

 -- Drew Parsons <dparsons@debian.org>  Thu, 11 Jul 2024 21:58:29 +0200

mpi4py (3.1.6-3) unstable; urgency=medium

  * fix debian patch s)kip_failing_tests_32bit_mpich.patch
    - treat armel, armhf, hppa machine ids as prefixes (arm*, parisc*)
      (it's actually armv7l, parisc64 on porterboxes)
    - skip testArgsOnlyAtRootMultiple (test_spawn) on powerpc with mpich
  * update intersphinx_use_local_inventory.patch to include local
    numpy docs. Build-Depends-Indep: python-numpy-doc

 -- Drew Parsons <dparsons@debian.org>  Thu, 11 Jul 2024 16:00:41 +0200

mpi4py (3.1.6-2) unstable; urgency=medium

  * debian patch skip_failing_tests_32bit_mpich.patch skips failing
    tests with 32-bit mpich. See upstream Issue#514. Closes: #1075980.
    - armel, armhf, hppa: testPackUnpackExternal (test_pack.py)
    - powerpc: testArgsOnlyAtRoot (test_spawn.py)

 -- Drew Parsons <dparsons@debian.org>  Thu, 11 Jul 2024 11:22:23 +0200

mpi4py (3.1.6-1) unstable; urgency=medium

  * New upstream release.
  * build and test over all supported (not requested) python versions
  * build docs against default python version
    (need built version to access MPI python extensions)
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Wed, 08 May 2024 17:46:54 +0200

mpi4py (3.1.5-7) unstable; urgency=medium

  * Team upload

  [ Zixing Liu ]
  * Un-break Sphinx documentation generation by removing PYTHONPATH overrides
    (Closes: #1066837)

 -- Graham Inggs <ginggs@debian.org>  Wed, 08 May 2024 13:23:44 +0000

mpi4py (3.1.5-6) unstable; urgency=medium

  * debian patch intersphinx_use_local_inventory.patch uses python3
    docs when building docs. Thanks Zixing Liu from Canonical.
    Closes: #1066837, #1063409
  * add Drew Parsons as uploader

 -- Drew Parsons <dparsons@debian.org>  Mon, 06 May 2024 19:33:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,9 @@
 Source: mpi4py
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
-           Michael Hanke <michael.hanke@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Drew Parsons <dparsons@debian.org>,
+           Yaroslav Halchenko <debian@onerussian.com>,
+           Michael Hanke <michael.hanke@gmail.com>,
 Section: python
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -16,8 +18,10 @@
                python3-setuptools
 Build-Depends-Indep: texinfo, texlive,
  latexmk, tex-gyre,
- texlive-latex-extra
-Standards-Version: 4.6.2
+ texlive-latex-extra,
+ python3-doc,
+ python-numpy-doc
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/science-team/mpi4py
 Vcs-Git: https://salsa.debian.org/science-team/mpi4py.git
 Homepage: https://github.com/mpi4py/mpi4py

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-PY3 = $(shell py3versions -vd)
-PY3VERS = $(shell py3versions -vr)
+PY3DEF = $(shell py3versions -vd)
+PY3VERS = $(shell py3versions -vs)
 
 LAST_CHANGE = $(shell dpkg-parsechangelog -S Date)
 BUILD_DATE  = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "$(LAST_CHANGE)")
@@ -64,8 +64,8 @@
 		--build-args "--mpicc=/usr/bin/mpicc$(MPI) --mpicxx=/usr/bin/mpicxx$(MPI)"
 
 override_dh_auto_build-indep: override_dh_auto_build-arch
-	PYTHONPATH=`pybuild --print "{build_dir}"` \
-	 make -C docs/source/usrman/ html man info latexpdf SPHINXOPTS="-D today=\"$(BUILD_DATE)\""
+	PYTHONPATH=`pybuild -p $(PY3DEF) --print "{build_dir}"` \
+	  make -C docs/source/usrman/ html man info latexpdf SPHINXOPTS="-D today=\"$(BUILD_DATE)\""
 
 override_dh_auto_install:
 	dh_auto_install
@@ -99,7 +99,7 @@
 	    /usr/bin/python$$vv $(CURDIR)/test/runtests.py -v || $(IGNORE_FAILED_TESTS); \
 	   echo "I: running tests with MPI (5 processes)"; \
 	   PYTHONPATH=`pybuild -p $$vv --print "{build_dir}"` \
-	    mpirun -n 5 /usr/bin/python$$vv $(CURDIR)/test/runtests.py -fv || $(IGNORE_FAILED_TESTS); \
+	    mpirun -v -n 5 /usr/bin/python$$vv $(CURDIR)/test/runtests.py -fv || $(IGNORE_FAILED_TESTS); \
 	  done; \
 	fi

=== debian/tests/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 # and is safe to oversubscribe with OpenMPI
 # but oversubscribing might be a problem (runs slow) with mpich
 
-Test-Command: OMPI_MCA_rmaps_base_oversubscribe=yes mpiexec -n 5 python3 test/runtests.py --verbose
+Test-Command: for pyver in `py3versions -vs`; do OMPI_MCA_rmaps_base_oversubscribe=yes mpiexec -v -n 5 python$pyver test/runtests.py --verbose; done
 Depends: python3-mpi4py,
+    python3-all,
     python3-cffi,
     python3-dill,
     python3-setuptools,

## mpi4py 4.0.1

=== debian/changelog ===
mpi4py (4.0.1-6deepin1) unstable; urgency=medium

  * Disable test as there is no network during build process

 -- zhoushicheng <zhoushicheng@uniontech.com>  Mon, 02 Dec 2024 15:07:04 +0800

mpi4py (4.0.1-6) unstable; urgency=medium

  * mips64el is in trouble. Reinstate version restriction. Test
    default python only and skip all TestRMA.
  * skip testAccumulate from test_rma_nb on bigendian architectures
    (s390x ppc64 sparc64, not alpha). Skip separately from DMA skips.

 -- Drew Parsons <dparsons@debian.org>  Tue, 19 Nov 2024 21:55:01 +0100

mpi4py (4.0.1-5) unstable; urgency=medium

  * update test skips
    - add alpha, sparc64 to the DMA skip list
    - DMA skip arches also skip testGetAccumulate
    - mips64el skips all TestRMA
  * revert mips64el version restriction, run tests on all supported
    python versions. The problem was TestRMA.

 -- Drew Parsons <dparsons@debian.org>  Tue, 19 Nov 2024 11:53:52 +0100

mpi4py (4.0.1-4) unstable; urgency=medium

  * s390x ppc64: skip all TestDPM tests (test_dynproc.py)
    see https://github.com/mpi4py/mpi4py/issues/586
    Closes: #1087609. Future ref. #1087800.
  * apply test skips to serial build tests
  * debian/rules: explicitly set DEB_HOST_ARCH
  * mips64el times out. Run build tests on default python only

 -- Drew Parsons <dparsons@debian.org>  Mon, 18 Nov 2024 23:37:00 +0100

mpi4py (4.0.1-3) unstable; urgency=medium

  * s390x ppc64: skip testConnectAccept too

 -- Drew Parsons <dparsons@debian.org>  Mon, 18 Nov 2024 02:09:27 +0100

mpi4py (4.0.1-2) unstable; urgency=medium

  * skip testAcceptConnect (test_dynproc.TestDPM) on s390x ppc64
    which segfaults with PMIX_ERR_BAD_PARAM. Closes: #1087609.
  * reinstate skipping testPackUnpackExternal on sparc64.
    OpenMPI 4.1.2 broke memory alignment on sparc64,
    see https://github.com/mpi4py/mpi4py/issues/147
    Closes: #1059791

 -- Drew Parsons <dparsons@debian.org>  Mon, 18 Nov 2024 00:23:20 +0100

mpi4py (4.0.1-1) unstable; urgency=medium

  * New upstream release
    - applies debian patch fix_symbols_PR549.patch

 -- Drew Parsons <dparsons@debian.org>  Sun, 17 Nov 2024 15:47:58 +0100

mpi4py (4.0.0-9) unstable; urgency=medium

  * Team upload.
  * Use the new OpenMPI 5 environment variable to allow oversubscription.
    This should allow the package to be built on systems with a single CPU.

 -- Santiago Vila <sanvila@debian.org>  Fri, 08 Nov 2024 21:55:00 +0100

mpi4py (4.0.0-8) unstable; urgency=medium

  * python3-mpi4py Breaks: python3-pyzoltan (<< 1.0.1-10~)
    mpi4py 4 requires pyzoltan to patch the definition of MPI_Session

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 Sep 2024 09:51:16 +0200

mpi4py (4.0.0-7) unstable; urgency=medium

  * update debian/copyright: mpi4py 4 was released under BSD-3-clause
  * avoid oversubscribing tests (i386 takes 1 hour running 3 processes
    where only 2 are available). Use no more than the available number
    of processors, except do use at least 2 processes.

 -- Drew Parsons <dparsons@debian.org>  Sun, 22 Sep 2024 00:24:43 +0200

mpi4py (4.0.0-6) unstable; urgency=medium

  * debian/tests: fix test for DEB_HOST_ARCH (i386 uses 3 processes)

 -- Drew Parsons <dparsons@debian.org>  Mon, 16 Sep 2024 10:21:08 +0200

mpi4py (4.0.0-5) unstable; urgency=medium

  * update debian/tests
    - run tests from mpi4py-test script
    - report number of available processing units (nproc)
    - run i386 tests with 3 processors not 5.
      mpich is particularly slow on i386 (times out).

 -- Drew Parsons <dparsons@debian.org>  Sun, 15 Sep 2024 09:36:37 +0200

mpi4py (4.0.0-4) unstable; urgency=medium

  * debian patch fix_symbols_PR549.patch applies upstream PR#549 to
    fix access of library symbols during tests. Needed for mpich tests
    on 32-bit arches.

 -- Drew Parsons <dparsons@debian.org>  Fri, 13 Sep 2024 20:31:46 +0200

mpi4py (4.0.0-3) unstable; urgency=medium

  * Apply MPI4PY_TEST_SPAWN=false with tests on all arches to avoid
    spawn failures with OpenMPI 4. Requires GITHUB_ACTIONS=true to
    activate. Spawn is generally flakey with  OpenMPI 4. Reenable
    spawn tests later with OpenMPI 5. Closes: #1081459.

 -- Drew Parsons <dparsons@debian.org>  Thu, 12 Sep 2024 09:33:57 +0200

mpi4py (4.0.0-2) unstable; urgency=medium

  * update debian patch skip_ppc_failing_tests.patch to skip
    testArgsOnlyAtRoot on powerpc. See upstream Issue#541.

 -- Drew Parsons <dparsons@debian.org>  Tue, 10 Sep 2024 21:56:15 +0200

mpi4py (4.0.0-1exp2) experimental; urgency=medium

  * reinstate and update debian patch skip_ppc_failing_tests.patch.
    Add ppc skip to testCodeCharStr.
  * add debian patch skip_s390x_failing_tests.patch to skip
    test_util_pool.TestProcessPool.test_apply on s390x
  * reinstate debian/patches/skip_testPackUnpackExternal_sparc64.patch

 -- Drew Parsons <dparsons@debian.org>  Fri, 30 Aug 2024 11:43:15 +0200

mpi4py (4.0.0-1exp1) experimental; urgency=medium

  * Major new upstream release
    - Build-Depends: cython3
    - applies or deprecates debian patches
      docs_privacy.patch
      fix_docs.patch
      io_long_double_i386_2d868d7.patch
      mpich_32bit_13e8af6.patch
      up_no_modlibs
  * doc build no longer uses usrman subdir
  * mpi4py man page now provided in section 3
  * drop deprecated debian/missing-sources
  * new major release, make a clean sweep of patches: drop all debian
    patches skipping tests.

 -- Drew Parsons <dparsons@debian.org>  Mon, 29 Jul 2024 23:49:55 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,7 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
+
+DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
 PY3DEF = $(shell py3versions -vd)
 PY3VERS = $(shell py3versions -vs)
@@ -7,12 +9,7 @@
 LAST_CHANGE = $(shell dpkg-parsechangelog -S Date)
 BUILD_DATE  = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "$(LAST_CHANGE)")
 
-# build-time tests should be more reliable with these settings
-# see https://github.com/mpi4py/setup-mpi/blob/master/setup-mpi.sh#L65
-export OMPI_MCA_plm=isolated
-export OMPI_MCA_rmaps_base_oversubscribe=true
-export OMPI_MCA_btl_base_warn_component_unused=false
-export OMPI_MCA_btl_vader_single_copy_mechanism=none
+export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe
 
 # Specify a specific version of MPI to use in the build, otherwise
 # just use the default.
@@ -21,21 +18,14 @@
 export  http_proxy=http://127.0.0.1:9/
 export  https_proxy=http://127.0.0.1:9/
 
+# disable tests by default as network connection is not available
+RUNTEST=no
 
-# disable build tests for these arches:
-# x32 consistently times out on tests
-NO_TEST_ARCH_LIST = x32
-
-empty :=
-space := $(empty)$(empty)
-
-# run tests, or not
-RUNTEST=yes
-ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(NO_TEST_ARCH_LIST)$(space)))
-  RUNTEST=no
-endif
-ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-  RUNTEST=no
+ifeq ($(DEB_HOST_ARCH),mips64el)
+# mips64el times out. Run tests on default python only.
+    PY3VERS_TESTS = $(PY3DEF)
+else
+    PY3VERS_TESTS = $(PY3VERS)
 endif
 
 # hurd fails a couple of tests
@@ -47,6 +37,28 @@
 ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_IGNORE_FAILED_TESTS)$(space)))
   IGNORE_FAILED_TESTS=/bin/true
 endif
+
+# segfault via PMIX (PMIX_ERR_BAD_PARAM) in test_dynproc.TestDPM
+SKIP_PMIX_DPM_CONNECT_ARCH_LIST = s390x alpha ppc64 sparc64
+ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_PMIX_DPM_CONNECT_ARCH_LIST)$(space)))
+    SKIP_TEST_LIST += TestDPM
+endif
+
+# failing RMA tests from test_rma_nb
+SKIP_RMA_ACCUMULATE_ARCH_LIST = s390x ppc64 sparc64
+ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_RMA_ACCUMULATE_ARCH_LIST)$(space)))
+    SKIP_TEST_LIST += testAccumulate testGetAccumulate
+endif
+
+ifeq ($(DEB_HOST_ARCH),mips64el)
+    SKIP_TEST_LIST += TestRMA
+endif
+
+ifeq ($(DEB_HOST_ARCH),sparc64)
+    # OpenMPI broke memory alignment on sparc64, see https://github.com/mpi4py/mpi4py/issues/147
+    SKIP_TEST_LIST += testPackUnpackExternal
+endif
+
 
 %:
 	dh $@ --with sphinxdoc --buildsystem pybuild
@@ -65,7 +77,7 @@
 
 override_dh_auto_build-indep: override_dh_auto_build-arch
 	PYTHONPATH=`pybuild -p $(PY3DEF) --print "{build_dir}"` \
-	  make -C docs/source/usrman/ html man info latexpdf SPHINXOPTS="-D today=\"$(BUILD_DATE)\""
+	  make -C docs/source/ html man info latexpdf SPHINXOPTS="-D today=\"$(BUILD_DATE)\""
 
 override_dh_auto_install:
 	dh_auto_install
@@ -92,14 +104,29 @@
 	if [ "$(RUNTEST)" = "no" ]; then \
 	  echo Build tests have been disabled; \
 	else \
-	  for vv in $(PY3VERS); do \
+	SKIP_TESTS=""; \
+	list_initialised=0; \
+	for t in $(SKIP_TEST_LIST); do \
+	    if [ $${list_initialised} = 0 ]; then \
+	        SKIP_TESTS="-x $$t"; \
+	        list_initialised=1; \
+	    else \
+	        SKIP_TESTS="$${SKIP_TESTS} -x $$t"; \
+	    fi; \
+	done; \
+	echo "skipping tests: $${SKIP_TESTS}"; \
+	  for vv in $(PY3VERS_TESTS); do \
 	  echo "I: testing using python$$vv"; \
 	   echo "I: running tests with single process"; \
 	   PYTHONPATH=`pybuild -p $$vv --print "{build_dir}"` \
-	    /usr/bin/python$$vv $(CURDIR)/test/runtests.py -v || $(IGNORE_FAILED_TESTS); \
-	   echo "I: running tests with MPI (5 processes)"; \
+	    GITHUB_ACTIONS=true MPI4PY_TEST_SPAWN=false \
+	    /usr/bin/python$$vv $(CURDIR)/test/runtests.py -v $${SKIP_TESTS} || $(IGNORE_FAILED_TESTS); \
+	   nproc=`nproc`; MIN_PROC=$$(( nproc > 2 ? nproc : 2 )); \
+	   NUM_PROC=$$(( MIN_PROC > 5 ? 5 : MIN_PROC )); \
+	   echo "I: running tests with MPI ($$NUM_PROC processes)"; \
 	   PYTHONPATH=`pybuild -p $$vv --print "{build_dir}"` \
-	    mpirun -v -n 5 /usr/bin/python$$vv $(CURDIR)/test/runtests.py -fv || $(IGNORE_FAILED_TESTS); \
+	    GITHUB_ACTIONS=true MPI4PY_TEST_SPAWN=false \
+	    mpirun -v -n $$NUM_PROC /usr/bin/python$$vv $(CURDIR)/test/runtests.py -fv $${SKIP_TESTS} || $(IGNORE_FAILED_TESTS); \
 	  done; \
 	fi
 
@@ -122,7 +149,7 @@
 	dh_auto_clean $@
 	rm -rf `find -name build -type d`
 	rm -rf `find -name _build -type d`
-	rm -rf docs/source/usrman/reference
+	rm -rf docs/source/reference
 
 	: # Remove Cython generated files
 	rm -f src/mpi4py.MPE.c src/mpi4py.MPI.c src/include/mpi4py/mpi4py.MPI_api.h

=== debian/tests/control ===
Tests: mpi4py-test
Depends: python3-mpi4py,
    python3-all,
    python3-cffi,
    python3-dill,
    python3-setuptools,
    python3-numpy,
    python3-simplejson,
    python3-yaml
Restrictions: allow-stderr


# Dummy test so that changes to other packages
# trigger our autopkgtests on ci.debian.net
Test-Command: /bin/true
Depends: libpmix-dev,
    libucx-dev [amd64 arm64 ppc64el],
Restrictions: hint-testsuite-triggers
